#include "Appevent.ch"
#include "Font.ch"
#include "Gra.CH"
#include "XBP.CH"
#include "common.CH"

****************************
PROCEDURE AppSys
*****************************
LOCAL aPos := {0,0}, aSize := {0,0}
LOCAL oDlg

   aSize             := AppDesktop():currentSize()
   aPos[1]           := 0.05 * aSize[1]
   aPos[2]           := 0.05 * aSize[2]
   aSize[1]          := aSize[1]*0.95
   aSize[2]          := aSize[2]*0.95

   oDlg              := XbpDialog():new( ,, aPos, aSize )
   oDlg:title        := "KRESLIMAPU"
   oDlg:taskList     := .T.
   oDlg:close        := {|| PostAppEvent( xbeP_Quit ) }
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( FONT_HELV_SMALL )

   AppMenu( oDlg )

   SetAppWindow( oDlg )

   SetAppFocus( oDlg )

RETURN

**********************************************
PROCEDURE AppMenu( oDlg )
**********************************************
LOCAL oMenuBar := oDlg:menuBar()
LOCAL oMenu

   oMenu := XbpMenu():new( oMenuBar )
   oMenu:title := "Aplikacia"
   oMenu:create()
   oMenu:addItem( { "Koniec", {|| PostAppEvent( xbeP_Quit ) } } )
   oMenuBar:addItem( { oMenu, } )

   oMenu := XbpMenu():new( oMenuBar )
   oMenu:title := "Funkcie"
   oMenu:create()

// change here
//
*  oMenu:addItem( { "Kresliciary  ", {|| kresliciary() } } )

// normal MDI
//
*  oMenu:addItem( { "Kresliciary  ", {|| Sub1(oDlg) } } )

// using Thread
//
   oMenu:addItem( { "Kresliciary  ", {|| CallThread(oDlg,1) } } )

   oMenuBar:addItem( { oMenu, } )

RETURN

PROCEDURE Main()
LOCAL nEvent := NIL, mp1 := NIL, mp2 := NIL, oXbp := NIL

   DO WHILE nEvent <> xbeP_Quit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE CallThread(oDlg,nMenu)
LOCAL oThread := Thread():new()

   DO CASE
      CASE nMenu = 1
         oThread:start( {|| Sub1(oDlg) } )

   ENDCASE

RETURN


*************************
PROCEDURE Sub1(oMain)
*************************
LOCAL nEvent := NIL, mp1 := NIL, mp2 := NIL, oXbp := NIL
LOCAL oDraw,oBMP
LOCAL oDialog,oPS,oDevice
LOCAL aSize  := oMain:drawingArea:Currentsize()
LOCAL aSizeu := {0,0}
LOCAL lExit  := .F.

// do not call twice
//
STATIC isRunning := .F.

   IF isRunning = .T.
      RETURN
   ENDIF
   isRunning := .T.

   aSizeu[1]=aSize[1]*0.8
   aSizeu[2]=aSize[2]*0.8

   * rozmer okna pre vykreslenie mapy

   oDialog:=XbpDialog():new(oMain:drawingArea ,, {0,0}, aSizeu ,,.F. )

   // close only this Windows
   //
   oDialog:Close  := {|| lExit  := .T. }

   // resize Childs on o:drawingArea
   //
   oDialog:drawingArea:resize := {| aOldSize, aNewSize, oSelf | Do_Resize(aOldSize, aNewSize, oSelf,oBMP) }
   oDialog:create()

   oDraw := XbpStatic():new(oDialog:drawingArea ,, {0,0}, oDialog:drawingArea:Currentsize() )
   oDraw:Type := XBPSTATIC_TYPE_BITMAP
   oDraw:Create()

   oPS:= XbpPresSpace():new()
   oDevice:=oDraw:winDevice()
   oPS:create(oDevice)

   // repaint "all" when need
   //
*  oDraw:paint := {| aRect, uNIL, oSelf | kresliciary(oPS) }

   // paint saved Bitmap when need
   //
*  oDraw:paint := {| aRect, uNIL, oSelf | DrawBMP(oBMP, oSelf,aRect) }

   CenterControl(oDialog,oMain)
   oDialog:show()
   SetAppFocus(oDialog)


   // draw now
   //
   oDraw:setPointer( ,XBPSTATIC_SYSICON_WAIT,XBPWINDOW_POINTERTYPE_SYSPOINTER)
   kresliciary(oPS)
   oDraw:setPointer( ,XBPSTATIC_SYSICON_DEFAULT,XBPWINDOW_POINTERTYPE_SYSPOINTER)

   // save it
   //
   oBMP := GraSaveScreen( oPS, oDraw:CurrentPos(), oDraw:CurrentSize() )

   // use o:SetCaption() without o:paint Slot ( draw by OS() )
   //
   oDraw:SetCaption( oBMP )

   * cyklus pre akanie na Quit, nhrada Inkey(0) ktor tu nefunguje
   DO WHILE !lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent = xbeP_Quit
            lExit  := .T.
      OTHERWISE
         oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oBMP:destroy()
   oDialog:destroy()

   isRunning := .F.

RETURN

PROCEDURE kresliciary(oPS)

// when have a lot of GRA you may "save" it in a Bitmap
// repaint a Bitmap is much quicker than Alaska GRA
//
   GraSetColor( oPS, GRA_CLR_RED )
   GraLine(oPS,{10,50},{600,50})
   GraSetColor( oPS, GRA_CLR_GREEN)
   GraLine(oPS,{10,100},{600,100})
   GraSetColor( oPS, GRA_CLR_BLUE)
   GraLine(oPS,{10,150},{600,150})
   GraSetColor( oPS, GRA_CLR_BLACK)
   GraLine(oPS,{10,200},{600,200})

RETURN

FUNCTION GraSaveScreen( oSourcePS, aPos, aSize )
LOCAL oBitmap   := XbpBitmap():new():create( oSourcePS )
LOCAL oTargetPS := XbpPresSpace():new():create()
LOCAL aSourceRect[4], aTargetRect

   aSourceRect[1] := aSourceRect[3] := aPos[1]
   aSourceRect[2] := aSourceRect[4] := aPos[2]
   aSourceRect[3] += aSize[1]
   aSourceRect[4] += aSize[2]

   aTargetRect    := {0, 0, aSize[1], aSize[2]}

   oBitmap:presSpace( oTargetPS )
   oBitmap:make( aSize[1], aSize[2] )

   GraBitBlt( oTargetPS, oSourcePS, aTargetRect, aSourceRect )

RETURN oBitmap

PROCEDURE GraRestScreen( oTargetPS, aPos, oBitmap )
   oBitmap:draw( oTargetPS, aPos )
RETURN

PROCEDURE DrawBMP(oBMP, oSelf,aRect )
LOCAL oLockPS
   oLockPS := oSelf:LockPS()
   oBMP:draw( oLockPS                        , ;
              aRect                          , ;
             { 0, 0, oBMP:xSize, oBMP:ySize }, ;
                                             , ;
              GRA_BLT_BBO_IGNORE )
   oSelf:UnlockPS()
RETURN

PROCEDURE Do_Resize(aOldSize, aNewSize, oSelf,oBMP)
LOCAL aChild
LOCAL i, iMax

   IF aOldSize[ 1 ] == 0 .AND. aOldSize[ 2 ] == 0           // was minimied
      aOldSize := aNewSize
      RETURN

   ELSEIF aNewSize[ 1 ] == 0 .OR. aNewSize[ 2 ] == 0        // now minimize
      RETURN

     // add "same Size", nothing had happend
   ELSEIF ( aNewSize[ 1 ] == aOldSize[ 1 ] .AND. ;
            aNewSize[ 2 ] == aOldSize[ 2 ] )
      RETURN
   ENDIF

   oSelf:LockUpdate( .T. )

   aChild := oSelf:Childlist()
   iMax := LEN(aChild)

   FOR i := 1 TO iMax
      DO CASE
         CASE aChild[i]:isDerivedFrom( "XbpStatic")
            aChild[i]:SetSize(aNewSize)
            IF aChild[i]:Type = XBPSTATIC_TYPE_BITMAP

               // need redraw
               //
               DrawBMP(oBMP, aChild[i], { 0, 0, aNewSize[ 1 ] , aNewSize[ 2 ] } )
            ENDIF
      ENDCASE
   NEXT

   oSelf:LockUpdate( .F. )
   oSelf:invalidateRect()

RETURN

*
* eof
*

